Index: branches/RWT/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp
===================================================================
--- branches/RWT/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 477)
+++ branches/RWT/modules/vci_mem_cache/caba/source/src/vci_mem_cache.cpp	(revision 495)
@@ -5993,12 +6011,8 @@
           r_cas_wdata = m_cmd_cas_wdata_fifo.read();
 
-        if(r_cas_cpt.read() >3)  // more than 4 flits...
-        {
-          std::cout << "VCI_MEM_CACHE ERROR in CAS_IDLE state : illegal CAS command"
-                    << std::endl;
-          exit(0);
-        }
-
-        if(r_cas_cpt.read() ==2)
+        assert( (r_cas_cpt.read() <= 3) and  // no more than 4 flits...
+        "MEMC ERROR in CAS_IDLE state: illegal CAS command");
+
+         if(r_cas_cpt.read() ==2)
           r_cas_wdata = m_cmd_cas_wdata_fifo.read();
 
@@ -6034,6 +6048,7 @@
     case CAS_DIR_LOCK:  // Read the directory
     {
-      if(r_alloc_dir_fsm.read() == ALLOC_DIR_CAS)
-      {
+        assert( (r_alloc_dir_fsm.read() == ALLOC_DIR_CAS) and
+        "MEMC ERROR in CAS_DIR_LOCK: Bad DIR allocation");
+
         size_t way = 0;
         DirectoryEntry entry(m_cache_directory.read(m_cmd_cas_addr_fifo.read(), way));
@@ -6045,7 +6060,4 @@
         r_cas_way        = way;
         r_cas_copy       = entry.owner.srcid;
-#if L1_MULTI_CACHE
-        r_cas_copy_cache = entry.owner.cache_id;
-#endif
         r_cas_copy_inst  = entry.owner.inst;
         r_cas_ptr        = entry.ptr;
@@ -6065,16 +6077,5 @@
         }
 #endif
-      }
-      else
-      {
-        std::cout
-            << "VCI_MEM_CACHE ERROR " << name()
-            << " CAS_DIR_LOCK state" << std::endl
-            << "Bad DIR allocation"   << std::endl;
-
-        exit(0);
-      }
-
-      break;
+        break;
     }
     /////////////////////
@@ -6094,7 +6095,4 @@
       entry.tag            = r_cas_tag.read();
       entry.owner.srcid    = r_cas_copy.read();
-#if L1_MULTI_CACHE
-      entry.owner.cache_id = r_cas_copy_cache.read();
-#endif
       entry.owner.inst     = r_cas_copy_inst.read();
       entry.count          = r_cas_count.read();
@@ -6156,11 +6154,9 @@
     {
       // The CAS is a success => sw access to the llsc_global_table
-      // BUG LLSC
-      addr_t      nline      = m_nline[(addr_t)(m_cmd_cas_addr_fifo.read())];
-      m_llsc_table.sw(nline);
       //m_llsc_table.sw(m_cmd_cas_addr_fifo.read());
           /**//*std::cout << "MEMCACHE : from proc " << m_cmd_cas_srcid_fifo.read()
                         << " | @ " << std::hex << m_cmd_cas_addr_fifo.read()
                         << " | WRITE (cas triggered)" << std::endl;*/
+      m_llsc_table.sw(m_nline[(addr_t)m_cmd_cas_addr_fifo.read()],m_x[(addr_t)(m_cmd_cas_addr_fifo.read())],m_x[(addr_t)(m_cmd_cas_addr_fifo.read())]);
 
       // test coherence request
@@ -6170,4 +6166,11 @@
         {
           r_cas_fsm = CAS_BC_TRT_LOCK;    // broadcast invalidate required
+#if DEBUG_MEMC_CAS
+if(m_debug)
+std::cout << "  <MEMC " << name() << " CAS_DIR_HIT_WRITE>"
+          << " Broacast Inval required" 
+          << " / copies = " << r_cas_count.read() << std::endl;
+#endif
+
         }
         else if(!r_cas_to_cc_send_multi_req.read() and
@@ -6175,8 +6178,19 @@
         {
           r_cas_fsm = CAS_UPT_LOCK;       // multi update required
+#if DEBUG_MEMC_CAS
+if(m_debug)
+std::cout << "  <MEMC " << name() << " CAS_DIR_HIT_WRITE>"
+          << " Multi Inval required" 
+          << " / copies = " << r_cas_count.read() << std::endl;
+#endif
         }
         else
         {
           r_cas_fsm = CAS_WAIT;
+#if DEBUG_MEMC_CAS
+if(m_debug)
+std::cout << "  <MEMC " << name() << " CAS_DIR_HIT_WRITE>"
+          << " CC_SEND FSM busy: release all locks and retry" << std::endl;
+#endif
         }
       }
@@ -6193,14 +6207,4 @@
 
         r_cas_fsm = CAS_RSP_SUCCESS;
-
-        // monitor
-        if(m_monitor_ok)
-        {
-          addr_t address = m_cmd_cas_addr_fifo.read();
-          check_monitor( address, r_cas_wdata.read(), false);
-
-          if(r_cas_cpt.read() == 4)
-            check_monitor( address+4, m_cmd_cas_wdata_fifo.read(), false);
-        }
 
 #if DEBUG_MEMC_CAS
@@ -6256,13 +6260,4 @@
           r_cas_fsm = CAS_UPT_HEAP_LOCK;
 
-          // monitor
-          if(m_monitor_ok)
-          {
-            addr_t address = m_cmd_cas_addr_fifo.read();
-            check_monitor( address, r_cas_wdata.read(), false);
-
-            if(r_cas_cpt.read() ==4)
-              check_monitor( address+4, m_cmd_cas_wdata_fifo.read(), false);
-          }
         }
         else       //  releases the locks protecting UPT and DIR UPT full
@@ -6350,7 +6345,4 @@
         cas_to_cc_send_fifo_inst    = r_cas_copy_inst.read();
         cas_to_cc_send_fifo_srcid   = r_cas_copy.read();
-#if L1_MULTI_CACHE
-        cas_to_cc_send_fifo_cache_id= r_cas_copy_cache.read();
-#endif
         if(r_cas_count.read() == 1)  // one single copy
         {
@@ -6387,7 +6379,4 @@
       HeapEntry entry = m_heap.read(r_cas_ptr.read());
       cas_to_cc_send_fifo_srcid    = entry.owner.srcid;
-#if L1_MULTI_CACHE
-      cas_to_cc_send_fifo_cache_id = entry.owner.cache_id;
-#endif
       cas_to_cc_send_fifo_inst     = entry.owner.inst;
       cas_to_cc_send_fifo_put = true;
@@ -6421,44 +6410,28 @@
     case CAS_BC_TRT_LOCK:      // check the TRT to register a PUT transaction
     {
-      if(r_alloc_trt_fsm.read() == ALLOC_TRT_CAS)
-      {
-        if(!r_cas_to_ixr_cmd_req)    // we can transfer the request to IXR_CMD FSM
-        {
-          // fill the data buffer
-          size_t word = m_x[(addr_t)(m_cmd_cas_addr_fifo.read())];
-          for(size_t i = 0; i<m_words; i++)
-          {
-            if(i == word)
+        assert( (r_alloc_dir_fsm.read() == ALLOC_DIR_CAS) and
+        "MEMC ERROR in CAS_BC_TRT_LOCK state: Bas DIR allocation");
+
+        if(r_alloc_trt_fsm.read() == ALLOC_TRT_CAS)
+        {
+            size_t wok_index = 0;
+            bool   wok       = !m_trt.full(wok_index);
+            if( wok )
             {
-              r_cas_to_ixr_cmd_data[i] = r_cas_wdata.read();
-            }
-            else if((i == word+1) and (r_cas_cpt.read() == 4))   // 64 bit CAS
-            {
-              r_cas_to_ixr_cmd_data[i] = m_cmd_cas_wdata_fifo.read();
+                r_cas_trt_index = wok_index;
+                r_cas_fsm       = CAS_BC_IVT_LOCK;
             }
             else
             {
-              r_cas_to_ixr_cmd_data[i] = r_cas_data[i].read();
+                r_cas_fsm       = CAS_WAIT;
+                m_cpt_cas_fsm_n_trt_lock++;
             }
-          }
-          size_t wok_index = 0;
-          bool   wok       = !m_trt.full(wok_index);
-          if(wok)
-          {
-            r_cas_trt_index = wok_index;
-            r_cas_fsm       = CAS_BC_IVT_LOCK;
-          }
-          else
-          {
-            r_cas_fsm       = CAS_WAIT;
-          }
-        }
-        else
-        {
-          r_cas_fsm = CAS_WAIT;
-        }
-        m_cpt_cas_fsm_n_trt_lock++;
-      }
-
+
+#if DEBUG_MEMC_CAS
+if(m_debug)
+std::cout << "  <MEMC " << name() << " CAS_BC_TRT_LOCK> Check TRT"
+          << " : wok = " << wok << " / index = " << wok_index << std::endl;
+#endif
+        }
       m_cpt_cas_fsm_trt_lock++;
 
@@ -6502,13 +6475,4 @@
             m_cache_data.write(way, set, word+1, m_cmd_cas_wdata_fifo.read());
 
-          // monitor
-          if(m_monitor_ok)
-          {
-            addr_t address = m_cmd_cas_addr_fifo.read();
-            check_monitor( address, r_cas_wdata.read(), false);
-
-            if(r_cas_cpt.read() ==4)
-              check_monitor( address+4, m_cmd_cas_wdata_fifo.read(), false);
-          }
           r_cas_upt_index = index;
           r_cas_fsm = CAS_BC_DIR_INVAL;
@@ -6537,20 +6501,36 @@
     case CAS_BC_DIR_INVAL:  // Register the PUT transaction in TRT, and inval the DIR entry
     {
-      if((r_alloc_trt_fsm.read() == ALLOC_TRT_CAS) and
-         (r_alloc_ivt_fsm.read() == ALLOC_IVT_CAS) and
-         (r_alloc_dir_fsm.read() == ALLOC_DIR_CAS))
-      {
-        // set TRT
-        m_trt.set(r_cas_trt_index.read(),
-                              false,    // PUT request to XRAM
-                              m_nline[(addr_t)(m_cmd_cas_addr_fifo.read())],
-                              0,
-                              0,
-                              0,
-                              false,    // not a processor read
-                              0,
-                              0,
-                              std::vector<be_t> (m_words,0),
-                              std::vector<data_t> (m_words,0));
+        assert( (r_alloc_dir_fsm.read() == ALLOC_DIR_CAS) and
+        "MEMC ERROR in CAS_BC_DIR_INVAL state: Bad DIR allocation");
+
+        assert( (r_alloc_trt_fsm.read() == ALLOC_TRT_CAS) and
+        "MEMC ERROR in CAS_BC_DIR_INVAL state: Bad TRT allocation");
+
+        assert( (r_alloc_ivt_fsm.read() == ALLOC_IVT_CAS) and
+        "MEMC ERROR in CAS_BC_DIR_INVAL state: Bad IVT allocation");
+
+        std::vector<data_t> data_vector;
+        data_vector.clear();
+        size_t word = m_x[(addr_t)(m_cmd_cas_addr_fifo.read())];
+        for(size_t i=0; i<m_words; i++)
+        {
+            if(i == word)                                        // first modified word
+                data_vector.push_back( r_cas_wdata.read() );     
+            else if((i == word+1) and (r_cas_cpt.read() == 4))   // second modified word
+                data_vector.push_back( m_cmd_cas_wdata_fifo.read() );
+            else                                                 // unmodified words
+                data_vector.push_back( r_cas_data[i].read() );
+        }
+        m_trt.set( r_cas_trt_index.read(),
+                   false,    // PUT request 
+                   m_nline[(addr_t)(m_cmd_cas_addr_fifo.read())],
+                   0,
+                   0,
+                   0,
+                   false,    // not a processor read
+                   0,
+                   0,
+                   std::vector<be_t> (m_words,0),
+                   data_vector );
 
         // invalidate directory entry
@@ -6558,12 +6538,9 @@
         entry.valid         = false;
         entry.dirty         = false;
-        entry.tag         = 0;
+        entry.tag           = 0;
         entry.is_cnt        = false;
         entry.lock          = false;
         entry.count         = 0;
         entry.owner.srcid   = 0;
-#if L1_MULTI_CACHE
-        entry.owner.cache_id= 0;
-#endif
         entry.owner.inst    = false;
         entry.ptr           = 0;
@@ -6576,14 +6553,8 @@
 #if DEBUG_MEMC_CAS
 if(m_debug)
-std::cout << "  <MEMC " << name()
-          << " CAS_BC_DIR_INVAL> Register the PUT in TRT and invalidate DIR entry"
-          << " / nline = " << std::hex << m_nline[(addr_t)(m_cmd_cas_addr_fifo.read())]
-          << " / set = " << std::dec << set << " / way = " << way << std::endl;
-#endif
-      }
-      else
-      {
-        assert(false and "LOCK ERROR in CAS_FSM, STATE = CAS_BC_DIR_INVAL");
-      }
+        m_trt.print(0);
+std::cout << "  <MEMC " << name() << " CAS_BC_DIR_INVAL> Inval DIR & register in TRT:"
+          << " address = " << m_cmd_cas_addr_fifo.read() << std::endl;
+#endif
       break;
     }
@@ -6591,6 +6562,6 @@
     case CAS_BC_CC_SEND:  // Request the broadcast inval to CC_SEND FSM
     {
-      if(!r_cas_to_cc_send_multi_req.read() and
-          !r_cas_to_cc_send_brdcast_req.read())
+      if( not r_cas_to_cc_send_multi_req.read() and
+          not r_cas_to_cc_send_brdcast_req.read())
       {
         r_cas_to_cc_send_multi_req    = false;
@@ -6608,10 +6579,9 @@
     case CAS_BC_XRAM_REQ: // request the IXR FSM to start a put transaction
     {
-      if(!r_cas_to_ixr_cmd_req)
+      if( not r_cas_to_ixr_cmd_req.read() )
       {
         r_cas_to_ixr_cmd_req     = true;
-        r_cas_to_ixr_cmd_write   = true;
-        r_cas_to_ixr_cmd_nline   = m_nline[(addr_t)(m_cmd_cas_addr_fifo.read())];
-        r_cas_to_ixr_cmd_trdid   = r_cas_trt_index.read();
+        r_cas_to_ixr_cmd_put     = true;
+        r_cas_to_ixr_cmd_index   = r_cas_trt_index.read();
         r_cas_fsm                = CAS_IDLE;
         cmd_cas_fifo_get         = true;
@@ -6622,13 +6592,9 @@
 std::cout << "  <MEMC " << name()
           << " CAS_BC_XRAM_REQ> Request a PUT transaction to IXR_CMD FSM" << std::hex
-          << " / nline = " << m_nline[(addr_t) m_cmd_cas_addr_fifo.read()]
+          << " / address = " << (addr_t) m_cmd_cas_addr_fifo.read()
           << " / trt_index = " << r_cas_trt_index.read() << std::endl;
 #endif
       }
-      else
-      {
-        std::cout << "ERROR in MEM_CACHE / CAS_BC_XRAM_REQ state"
-                  << " : request should not have been previously set" << std::endl;
-      }
+      
       break;
     }
@@ -6636,9 +6602,9 @@
     case CAS_RSP_FAIL:  // request TGT_RSP FSM to send a failure response
     {
-      if(!r_cas_to_tgt_rsp_req)
-      {
-        cmd_cas_fifo_get     = true;
+      if( not r_cas_to_tgt_rsp_req.read() )
+      {
+        cmd_cas_fifo_get       = true;
         r_cas_cpt              = 0;
-        r_cas_to_tgt_rsp_req = true;
+        r_cas_to_tgt_rsp_req   = true;
         r_cas_to_tgt_rsp_data  = 1;
         r_cas_to_tgt_rsp_srcid = m_cmd_cas_srcid_fifo.read();
@@ -6658,5 +6624,5 @@
     case CAS_RSP_SUCCESS:  // request TGT_RSP FSM to send a success response
     {
-      if(!r_cas_to_tgt_rsp_req)
+      if( not r_cas_to_tgt_rsp_req.read() )
       {
         cmd_cas_fifo_get       = true;
@@ -6687,5 +6653,5 @@
         bool hit_write = m_trt.hit_write(
                            m_nline[(addr_t) m_cmd_cas_addr_fifo.read()]);
-        bool wok = !m_trt.full(index);
+        bool wok = not m_trt.full(index);
 
 #if DEBUG_MEMC_CAS
@@ -6719,6 +6685,7 @@
     case CAS_MISS_TRT_SET: // register the GET transaction in TRT
     {
-      if(r_alloc_trt_fsm.read() == ALLOC_TRT_CAS)
-      {
+        assert( (r_alloc_trt_fsm.read() == ALLOC_TRT_CAS) and
+        "MEMC ERROR in CAS_MISS_TRT_SET state: Bad TRT allocation");
+
         std::vector<be_t> be_vector;
         std::vector<data_t> data_vector;
@@ -6732,14 +6699,14 @@
 
         m_trt.set(r_cas_trt_index.read(),
-                              true,   // read request
-                              m_nline[(addr_t) m_cmd_cas_addr_fifo.read()],
-                              m_cmd_cas_srcid_fifo.read(),
-                              m_cmd_cas_trdid_fifo.read(),
-                              m_cmd_cas_pktid_fifo.read(),
-                              false,    // write request from processor
-                              0,
-                              0,
-                              be_vector,
-                              data_vector);
+                  true,   // read request
+                  m_nline[(addr_t) m_cmd_cas_addr_fifo.read()],
+                  m_cmd_cas_srcid_fifo.read(),
+                  m_cmd_cas_trdid_fifo.read(),
+                  m_cmd_cas_pktid_fifo.read(),
+                  false,    // write request from processor
+                  0,
+                  0,
+                  be_vector,
+                  data_vector);
         r_cas_fsm = CAS_MISS_XRAM_REQ;
 
@@ -6747,4 +6714,5 @@
         if(m_debug)
         {
+          m_trt.print(0);
           std::cout << "  <MEMC " << name() << " CAS_MISS_TRT_SET> Register a GET transaction in TRT" << std::hex
                     << " / nline = " << m_nline[(addr_t) m_cmd_cas_addr_fifo.read()]
@@ -6752,5 +6720,4 @@
         }
 #endif
-      }
       break;
     }
@@ -6758,19 +6725,16 @@
     case CAS_MISS_XRAM_REQ:  // request the IXR_CMD FSM to fetch the missing line
     {
-      if(!r_cas_to_ixr_cmd_req)
+      if( not r_cas_to_ixr_cmd_req.read() )
       {
         r_cas_to_ixr_cmd_req        = true;
-        r_cas_to_ixr_cmd_write      = false;
-        r_cas_to_ixr_cmd_trdid      = r_cas_trt_index.read();
-        r_cas_to_ixr_cmd_nline      = m_nline[(addr_t) m_cmd_cas_addr_fifo.read()];
+        r_cas_to_ixr_cmd_put        = false;
+        r_cas_to_ixr_cmd_index      = r_cas_trt_index.read();
         r_cas_fsm                   = CAS_WAIT;
 
 #if DEBUG_MEMC_CAS
-        if(m_debug)
-        {
-          std::cout << "  <MEMC " << name() << " CAS_MISS_XRAM_REQ> Request a GET transaction to IXR_CMD FSM" << std::hex
-                    << " / nline = " << m_nline[(addr_t) m_cmd_cas_addr_fifo.read()]
-                    << " / trt_index = " << r_cas_trt_index.read() << std::endl;
-        }
+if(m_debug)
+std::cout << "  <MEMC " << name() << " CAS_MISS_XRAM_REQ> Request a GET transaction"
+          << " / address = " << std::hex << (addr_t) m_cmd_cas_addr_fifo.read()
+          << " / trt_index = " << std::dec << r_cas_trt_index.read() << std::endl;
 #endif
       }
@@ -7643,5 +7607,4 @@
         r_tgt_rsp_cpt = r_cleanup_to_tgt_rsp_first_word.read();
       }
-
       else if(r_config_to_tgt_rsp_req)    r_tgt_rsp_fsm = TGT_RSP_CONFIG;
       else if(r_tgt_cmd_to_tgt_rsp_req)   r_tgt_rsp_fsm = TGT_RSP_TGT_CMD;
@@ -7780,5 +7743,5 @@
     }
     /////////////////////
-    case TGT_RSP_TGT_CMD: // send the response for a segmentation violation
+    case TGT_RSP_TGT_CMD: // send the response for a configuration access
     {
       if ( p_vci_tgt.rspack )
@@ -7792,8 +7755,9 @@
   std::cout
     << "  <MEMC " << name()
-    << " TGT_RSP_TGT_CMD> Segmentation violation response"
+    << " TGT_RSP_TGT_CMD> Send response for a configuration access"
     << " / rsrcid = " << std::hex << r_tgt_cmd_to_tgt_rsp_srcid.read()
     << " / rtrdid = " << r_tgt_cmd_to_tgt_rsp_trdid.read()
     << " / rpktid = " << r_tgt_cmd_to_tgt_rsp_pktid.read()
+    << " / error = " << r_tgt_cmd_to_tgt_rsp_error.read()
     << std::endl;
 }
@@ -7916,5 +7880,4 @@
 #endif
 
-
         uint32_t last_word_idx = r_cleanup_to_tgt_rsp_first_word.read() + r_cleanup_to_tgt_rsp_length.read() - 1;
         bool is_ll = ((r_cleanup_to_tgt_rsp_pktid.read() & 0x7) == TYPE_LL);
@@ -7972,5 +7935,4 @@
           }
         }
-
       }
       break;
@@ -8114,5 +8076,4 @@
               else if (r_multi_ack_fsm.read() == MULTI_ACK_UPT_LOCK)
                   r_alloc_upt_fsm = ALLOC_UPT_MULTI_ACK;
-            
               else
                   m_cpt_upt_unused++;
@@ -8145,5 +8106,4 @@
               else if (r_cas_fsm.read() == CAS_UPT_LOCK)
                   r_alloc_upt_fsm = ALLOC_UPT_CAS;
-            
               else
                   m_cpt_upt_unused++;
@@ -8178,5 +8138,5 @@
               r_alloc_ivt_fsm = ALLOC_IVT_READ;
             
-            else if (r_xram_rsp_fsm.read() == XRAM_RSP_INVAL_LOCK)
+            else if (r_xram_rsp_fsm.read() == XRAM_RSP_IVT_LOCK)
               r_alloc_ivt_fsm = ALLOC_IVT_XRAM_RSP;
 
@@ -8188,5 +8148,5 @@
                   r_alloc_ivt_fsm = ALLOC_IVT_CAS;
         
-            else if (r_config_fsm.read() == CONFIG_DIR_IVT_LOCK)
+            else if (r_config_fsm.read() == CONFIG_IVT_LOCK)
               r_alloc_ivt_fsm = ALLOC_IVT_CONFIG;
 
@@ -8200,5 +8160,5 @@
           if (r_read_fsm.read() != READ_IVT_LOCK) 
           {
-            if (r_xram_rsp_fsm.read() == XRAM_RSP_INVAL_LOCK)
+            if (r_xram_rsp_fsm.read() == XRAM_RSP_IVT_LOCK)
               r_alloc_ivt_fsm = ALLOC_IVT_XRAM_RSP;
 
@@ -8210,5 +8170,5 @@
                   r_alloc_ivt_fsm = ALLOC_IVT_CAS;
         
-            else if (r_config_fsm.read() == CONFIG_DIR_IVT_LOCK)
+            else if (r_config_fsm.read() == CONFIG_IVT_LOCK)
               r_alloc_ivt_fsm = ALLOC_IVT_CONFIG;
           
@@ -8217,5 +8177,4 @@
                 (r_write_fsm.read() == WRITE_MISS_IVT_LOCK))
               r_alloc_ivt_fsm = ALLOC_IVT_WRITE;
-
             else
               m_cpt_ivt_unused++;
@@ -8225,5 +8184,5 @@
       //////////////////////////
       case ALLOC_IVT_XRAM_RSP:         // allocated to XRAM_RSP FSM
-          if(r_xram_rsp_fsm.read() != XRAM_RSP_INVAL_LOCK)
+          if(r_xram_rsp_fsm.read() != XRAM_RSP_IVT_LOCK)
           {
             if ((r_cleanup_fsm.read() == CLEANUP_IVT_LOCK) or
@@ -8234,5 +8193,5 @@
               r_alloc_ivt_fsm = ALLOC_IVT_CAS;
 
-            else if (r_config_fsm.read() == CONFIG_DIR_IVT_LOCK)
+            else if (r_config_fsm.read() == CONFIG_IVT_LOCK)
               r_alloc_ivt_fsm = ALLOC_IVT_CONFIG;
 
@@ -8259,5 +8218,5 @@
               r_alloc_ivt_fsm = ALLOC_IVT_CAS;
 
-            else if (r_config_fsm.read() == CONFIG_DIR_IVT_LOCK)
+            else if (r_config_fsm.read() == CONFIG_IVT_LOCK)
               r_alloc_ivt_fsm = ALLOC_IVT_CONFIG;
 
@@ -8270,5 +8229,5 @@
               r_alloc_ivt_fsm = ALLOC_IVT_READ;
 
-            else if (r_xram_rsp_fsm.read() == XRAM_RSP_INVAL_LOCK)
+            else if (r_xram_rsp_fsm.read() == XRAM_RSP_IVT_LOCK)
               r_alloc_ivt_fsm = ALLOC_IVT_XRAM_RSP;
 
@@ -8282,5 +8241,5 @@
           if (r_cas_fsm.read() != CAS_BC_IVT_LOCK)
           {
-            if (r_config_fsm.read() == CONFIG_DIR_IVT_LOCK)
+            if (r_config_fsm.read() == CONFIG_IVT_LOCK)
               r_alloc_ivt_fsm = ALLOC_IVT_CONFIG;
 
@@ -8293,5 +8252,5 @@
               r_alloc_ivt_fsm = ALLOC_IVT_READ;
 
-            else if (r_xram_rsp_fsm.read() == XRAM_RSP_INVAL_LOCK)
+            else if (r_xram_rsp_fsm.read() == XRAM_RSP_IVT_LOCK)
               r_alloc_ivt_fsm = ALLOC_IVT_XRAM_RSP;
 
@@ -8307,5 +8266,5 @@
       //////////////////////////
       case ALLOC_IVT_CONFIG:           // allocated to CONFIG FSM
-          if (r_config_fsm.read() != CONFIG_DIR_IVT_LOCK)
+          if (r_config_fsm.read() != CONFIG_IVT_LOCK)
           {
             if ((r_write_fsm.read() == WRITE_BC_IVT_LOCK) or
@@ -8317,5 +8276,5 @@
               r_alloc_ivt_fsm = ALLOC_IVT_READ;
 
-            else if (r_xram_rsp_fsm.read() == XRAM_RSP_INVAL_LOCK)
+            else if (r_xram_rsp_fsm.read() == XRAM_RSP_IVT_LOCK)
               r_alloc_ivt_fsm = ALLOC_IVT_XRAM_RSP;
 
@@ -8326,5 +8285,4 @@
             else if(r_cas_fsm.read() == CAS_BC_IVT_LOCK)
               r_alloc_ivt_fsm = ALLOC_IVT_CAS;
-
             else
               m_cpt_ivt_unused++;
@@ -8361,5 +8319,7 @@
     if ( (r_config_fsm.read()    != CONFIG_DIR_REQ) and
          (r_config_fsm.read()    != CONFIG_DIR_ACCESS) and
-         (r_config_fsm.read()    != CONFIG_DIR_IVT_LOCK) )
+         (r_config_fsm.read()    != CONFIG_TRT_LOCK) and
+         (r_config_fsm.read()    != CONFIG_TRT_SET) and
+         (r_config_fsm.read()    != CONFIG_IVT_LOCK) )
     {
         if(r_read_fsm.read() == READ_DIR_REQ)
@@ -8417,5 +8377,5 @@
       if(((r_write_fsm.read()       != WRITE_DIR_REQ)  and
           (r_write_fsm.read()       != WRITE_DIR_LOCK)  and
-          (r_write_fsm.read()       != WRITE_DIR_READ)  and
+          (r_write_fsm.read()       != WRITE_BC_DIR_READ)  and
           (r_write_fsm.read()       != WRITE_DIR_HIT)  and
           (r_write_fsm.read()       != WRITE_BC_TRT_LOCK)  and
@@ -8530,5 +8490,5 @@
       if( (r_xram_rsp_fsm.read() != XRAM_RSP_DIR_LOCK) and
         (r_xram_rsp_fsm.read() != XRAM_RSP_TRT_COPY) and
-        (r_xram_rsp_fsm.read() != XRAM_RSP_INVAL_LOCK))
+        (r_xram_rsp_fsm.read() != XRAM_RSP_IVT_LOCK))
       {
         if(r_config_fsm.read() == CONFIG_DIR_REQ)
@@ -8579,4 +8539,12 @@
           r_alloc_trt_fsm = ALLOC_TRT_CAS;
 
+        else if((r_ixr_cmd_fsm.read() == IXR_CMD_READ_TRT) or
+                (r_ixr_cmd_fsm.read() == IXR_CMD_WRITE_TRT) or
+                (r_ixr_cmd_fsm.read() == IXR_CMD_CAS_TRT) or
+                (r_ixr_cmd_fsm.read() == IXR_CMD_XRAM_TRT) or
+                (r_ixr_cmd_fsm.read() == IXR_CMD_CLEANUP_TRT) or
+                (r_ixr_cmd_fsm.read() == IXR_CMD_CONFIG_TRT) )
+          r_alloc_trt_fsm = ALLOC_TRT_IXR_CMD;
+ 
         else if((r_xram_rsp_fsm.read()  == XRAM_RSP_DIR_LOCK) and
                 (r_alloc_dir_fsm.read() == ALLOC_DIR_XRAM_RSP))
@@ -8587,4 +8555,7 @@
           r_alloc_trt_fsm = ALLOC_TRT_IXR_RSP;
 
+        else if( r_config_fsm.read() == CONFIG_TRT_LOCK ) 
+          r_alloc_trt_fsm = ALLOC_TRT_CONFIG;
+ 
         else if (r_cleanup_fsm.read() == CLEANUP_IXR_REQ)
           r_alloc_trt_fsm = ALLOC_TRT_CLEANUP;
@@ -8607,4 +8578,12 @@
           r_alloc_trt_fsm = ALLOC_TRT_CAS;
 
+        else if((r_ixr_cmd_fsm.read() == IXR_CMD_READ_TRT) or
+               (r_ixr_cmd_fsm.read() == IXR_CMD_WRITE_TRT) or
+               (r_ixr_cmd_fsm.read() == IXR_CMD_CAS_TRT) or
+               (r_ixr_cmd_fsm.read() == IXR_CMD_XRAM_TRT) or
+               (r_ixr_cmd_fsm.read() == IXR_CMD_CLEANUP_TRT) or
+               (r_ixr_cmd_fsm.read() == IXR_CMD_CONFIG_TRT) )
+          r_alloc_trt_fsm = ALLOC_TRT_IXR_CMD;
+ 
         else if((r_xram_rsp_fsm.read()  == XRAM_RSP_DIR_LOCK) and
                 (r_alloc_dir_fsm.read() == ALLOC_DIR_XRAM_RSP))
@@ -8618,4 +8597,7 @@
           r_alloc_trt_fsm = ALLOC_TRT_CLEANUP;
 
+        else if( r_config_fsm.read() == CONFIG_TRT_LOCK ) 
+          r_alloc_trt_fsm = ALLOC_TRT_CONFIG;
+
         else if(r_read_fsm.read() == READ_TRT_LOCK)
           r_alloc_trt_fsm = ALLOC_TRT_READ;
@@ -8634,6 +8616,14 @@
           (r_cas_fsm.read() != CAS_BC_IVT_LOCK))
       {
-        if((r_xram_rsp_fsm.read()  == XRAM_RSP_DIR_LOCK) and
-            (r_alloc_dir_fsm.read() == ALLOC_DIR_XRAM_RSP))
+       if((r_ixr_cmd_fsm.read() == IXR_CMD_READ_TRT) or
+          (r_ixr_cmd_fsm.read() == IXR_CMD_WRITE_TRT) or
+          (r_ixr_cmd_fsm.read() == IXR_CMD_CAS_TRT) or
+          (r_ixr_cmd_fsm.read() == IXR_CMD_XRAM_TRT) or
+          (r_ixr_cmd_fsm.read() == IXR_CMD_CLEANUP_TRT) or
+          (r_ixr_cmd_fsm.read() == IXR_CMD_CONFIG_TRT) )
+           r_alloc_trt_fsm = ALLOC_TRT_IXR_CMD;
+ 
+        else if((r_xram_rsp_fsm.read()  == XRAM_RSP_DIR_LOCK) and
+               (r_alloc_dir_fsm.read() == ALLOC_DIR_XRAM_RSP))
           r_alloc_trt_fsm = ALLOC_TRT_XRAM_RSP;
 
@@ -8645,4 +8635,7 @@
           r_alloc_trt_fsm = ALLOC_TRT_CLEANUP;
 
+        else if( r_config_fsm.read() == CONFIG_TRT_LOCK ) 
+          r_alloc_trt_fsm = ALLOC_TRT_CONFIG;
+ 
         else if(r_read_fsm.read() == READ_TRT_LOCK)
           r_alloc_trt_fsm = ALLOC_TRT_READ;
@@ -8658,4 +8651,40 @@
         m_cpt_cas_fsm_trt_used++;
       break;
+      ///////////////////////
+      case ALLOC_TRT_IXR_CMD:
+          if((r_ixr_cmd_fsm.read() != IXR_CMD_READ_TRT) and
+             (r_ixr_cmd_fsm.read() != IXR_CMD_WRITE_TRT) and
+             (r_ixr_cmd_fsm.read() != IXR_CMD_CAS_TRT) and
+             (r_ixr_cmd_fsm.read() != IXR_CMD_XRAM_TRT) and
+             (r_ixr_cmd_fsm.read() != IXR_CMD_CLEANUP_TRT) and
+             (r_ixr_cmd_fsm.read() != IXR_CMD_CONFIG_TRT))
+          {
+              if((r_xram_rsp_fsm.read()  == XRAM_RSP_DIR_LOCK) and
+                 (r_alloc_dir_fsm.read() == ALLOC_DIR_XRAM_RSP))
+                  r_alloc_trt_fsm = ALLOC_TRT_XRAM_RSP;
+
+              else if((r_ixr_rsp_fsm.read() == IXR_RSP_TRT_ERASE) or
+                      (r_ixr_rsp_fsm.read() == IXR_RSP_TRT_READ))
+                  r_alloc_trt_fsm = ALLOC_TRT_IXR_RSP;
+
+              else if (r_cleanup_fsm.read() == CLEANUP_IXR_REQ)
+                  r_alloc_trt_fsm = ALLOC_TRT_CLEANUP;
+
+
+              else if( r_config_fsm.read() == CONFIG_TRT_LOCK ) 
+                  r_alloc_trt_fsm = ALLOC_TRT_CONFIG;
+
+              else if(r_read_fsm.read() == READ_TRT_LOCK)
+                  r_alloc_trt_fsm = ALLOC_TRT_READ;
+
+              else if((r_write_fsm.read() == WRITE_MISS_TRT_LOCK) or
+                      (r_write_fsm.read() == WRITE_BC_TRT_LOCK))
+                  r_alloc_trt_fsm = ALLOC_TRT_WRITE;
+
+              else if((r_cas_fsm.read() == CAS_MISS_TRT_LOCK) or
+                      (r_cas_fsm.read() == CAS_BC_TRT_LOCK))
+                  r_alloc_trt_fsm = ALLOC_TRT_CAS;
+          }
+          break;
 
     ////////////////////////
@@ -8665,5 +8694,5 @@
           (r_xram_rsp_fsm.read()  != XRAM_RSP_TRT_COPY)  and
           (r_xram_rsp_fsm.read()  != XRAM_RSP_DIR_UPDT)  and
-          (r_xram_rsp_fsm.read()  != XRAM_RSP_INVAL_LOCK))
+          (r_xram_rsp_fsm.read()  != XRAM_RSP_IVT_LOCK))
       {
         if((r_ixr_rsp_fsm.read() == IXR_RSP_TRT_ERASE) or
@@ -8685,4 +8714,15 @@
           r_alloc_trt_fsm = ALLOC_TRT_CAS;
 
+        else if( r_config_fsm.read() == CONFIG_TRT_LOCK ) 
+          r_alloc_trt_fsm = ALLOC_TRT_CONFIG;
+ 
+        else if((r_ixr_cmd_fsm.read() == IXR_CMD_READ_TRT) or
+               (r_ixr_cmd_fsm.read() == IXR_CMD_WRITE_TRT) or
+               (r_ixr_cmd_fsm.read() == IXR_CMD_CAS_TRT) or
+               (r_ixr_cmd_fsm.read() == IXR_CMD_XRAM_TRT) or
+               (r_ixr_cmd_fsm.read() == IXR_CMD_CLEANUP_TRT) or
+               (r_ixr_cmd_fsm.read() == IXR_CMD_CONFIG_TRT) )
+          r_alloc_trt_fsm = ALLOC_TRT_IXR_CMD;
+
         else
           m_cpt_trt_unused++;
@@ -8697,6 +8737,8 @@
           (r_ixr_rsp_fsm.read() != IXR_RSP_TRT_READ))
       {
+        if( r_config_fsm.read() == CONFIG_TRT_LOCK ) 
+          r_alloc_trt_fsm = ALLOC_TRT_CONFIG;
         
-        if (r_cleanup_fsm.read() == CLEANUP_IXR_REQ)
+        else if (r_cleanup_fsm.read() == CLEANUP_IXR_REQ)
           r_alloc_trt_fsm = ALLOC_TRT_CLEANUP;
 
@@ -8711,4 +8753,12 @@
                 (r_cas_fsm.read() == CAS_BC_TRT_LOCK))
           r_alloc_trt_fsm = ALLOC_TRT_CAS;
+
+        else if((r_ixr_cmd_fsm.read() == IXR_CMD_READ_TRT) or
+                (r_ixr_cmd_fsm.read() == IXR_CMD_WRITE_TRT) or
+                (r_ixr_cmd_fsm.read() == IXR_CMD_CAS_TRT) or
+                (r_ixr_cmd_fsm.read() == IXR_CMD_XRAM_TRT) or
+                (r_ixr_cmd_fsm.read() == IXR_CMD_CLEANUP_TRT) or
+                (r_ixr_cmd_fsm.read() == IXR_CMD_CONFIG_TRT) )
+          r_alloc_trt_fsm = ALLOC_TRT_IXR_CMD;
 
         else if((r_xram_rsp_fsm.read()  == XRAM_RSP_DIR_LOCK) &&
